//terrain with shade

#include "spot.h"
float3 lightDir			: register	(c10);
float3 light_R			: register	(c11);
float3 light_L			: register	(c12);
float3 brake_L			: register	(c13);
float3 brake_R			: register	(c14);
float4 lightParameters	: register	(c15);

sampler	TexA			: register	(s0);
sampler	TexB			: register	(s1);
sampler	TexC			: register	(s2);//specular map
sampler	TexD			: register	(s3);//shade	map	
sampler	attenuationMap	: register	(s4);

float4	aux				: register	(c4);



float4 PShader(		float4	diffuse0:register(v0)	: COLOR0 ,  
					float4	diffuse1:register(v1)	: COLOR1 ,
					float2	tex0	:register(t0)	: TEXCOORD0,
					float2	tex1	:register(t1)	: TEXCOORD1,
					float2	tex2	:register(t2)	: TEXCOORD2,
					float2	tex3	:register(t3)	: TEXCOORD3,
					float4	vertPos	:register(t4)	: TEXCOORD4
				) : COLOR

{
	
	float4	outColorA;
	float4	outColorB;

	float4	texcolorA	= tex2D(TexA, tex0);
	float4	texcolorB	= tex2D(TexB, tex1);
	float4	texcolorC	= tex2D(TexC, tex2);
	float4	texcolorD	= tex2D(TexD, tex3);


	outColorA.xyz	= saturate(diffuse0		* texcolorA);
	outColorA.w		= saturate(diffuse0.w	* texcolorA.w);
	outColorB.xyz	= saturate(diffuse0		* texcolorB);
	outColorB.w		= saturate(diffuse0.w	* texcolorB.w);
	outColorB.w		= saturate(texcolorB.w  * diffuse0.w);
	outColorA.xyz	= saturate(lerp(outColorA,outColorB,outColorB.w));
	//add specular
	outColorB.xyz	= saturate(4 * texcolorC * diffuse1.w);
	outColorA.xyz	= saturate(outColorA + outColorB);
	//add shade
	//outColorA.xyz	= saturate(outColorA * texcolorD + diffuse1);
	//correction
	outColorB.w		= aux.w;
	outColorA.xyz	= lerp(aux, outColorA,outColorB.w);


	float distance = 	length(vertPos - light_R);
	if(distance > lightParameters.x)
	{
		outColorA.xyz *= 0.2;
	}
	else
	{
		outColorA.xyz *= (spot(vertPos,light_R,lightDir,attenuationMap,lightParameters.x) + 
			spot(vertPos,light_L,lightDir,attenuationMap,lightParameters.x));
	}
	outColorA.xyz *= lightParameters.w;

	return  outColorA;
}


/*
sampler	TexA			: register	(s0);
sampler	TexB			: register	(s1);
sampler	TexC			: register	(s2);//specular map
sampler	TexD			: register	(s3);//shade	map		
float4	aux				: register	(c4);


float4 PShader(		float4	diffuse0:register(v0)	: COLOR0 ,  
					float4	diffuse1:register(v1)	: COLOR1 ,
					float2	tex0	:register(t0)	: TEXCOORD0,
					float2	tex1	:register(t1)	: TEXCOORD1,
					float2	tex2	:register(t2)	: TEXCOORD2,
					float2	tex3	:register(t3)	: TEXCOORD3
				) : COLOR

{
	
	float4	outColorA;
	float4	outColorB;

	float4	texcolorA	= tex2D(TexA, tex0);
	float4	texcolorB	= tex2D(TexB, tex1);
	float4	texcolorC	= tex2D(TexC, tex2);
	float4	texcolorD	= tex2D(TexD, tex3);


	outColorA.xyz	= saturate(diffuse0		* texcolorA);
	outColorA.w		= saturate(diffuse0.w	* texcolorA.w);
	outColorB.xyz	= saturate(diffuse0		* texcolorB);
	outColorB.w		= saturate(diffuse0.w	* texcolorB.w);
	outColorB.w		= saturate(texcolorB.w  * diffuse0.w);
	outColorA.xyz	= saturate(lerp(outColorA,outColorB,outColorB.w));
	//add specular
	outColorB.xyz	= saturate(4 * texcolorC * diffuse1.w);
	outColorA.xyz	= saturate(outColorA + outColorB);
	//add shade
	outColorA.xyz	= saturate(outColorA * texcolorD + diffuse1);
	//correction
	outColorB.w		= aux.w;
	outColorA.xyz	= lerp(aux, outColorA,outColorB.w);
	return  outColorA;
}
*/
/*
ps_1_1

    def c0, 1, 1, 1, 1

    tex t0
    tex t1
    tex t2
    tex t3

    mul_sat r0.xyz, v0, t0
  + mul_sat r0.w, v0.w, t0.w
    mul_sat r1.xyz, v0, t1
  + mul_sat r1.w, v0.w, t1.w
    mul_sat r1.w, t1.w, v0.w

    lrp_sat r0.xyz, r1.w, r1, r0
	outColorA.xyz	= saturate(lerp(outColorA,outColorB,outColorB.w));


    mul_x4_sat r1.xyz, t2, v1.w
    add_sat r0.xyz, r0, r1
    mad_sat r0.xyz, r0, t3, v1

  + mov r1.w, c4.w
    lrp r0.xyz, r1.w, r0, c4
*/