#include "spot.h"
float3 lightDir			: register	(c10);
float3 light_R			: register	(c11);
float3 light_L			: register	(c12);
float3 brake_L			: register	(c13);
float3 brake_R			: register	(c14);
float4 lightParameters	: register	(c15);


sampler	TexA			: register	(s0);//diffuse
sampler	attenuationMap	: register	(s4);


float4 PShader(		float4	diffuse0:register(v0)	: COLOR0 ,  
					float4	diffuse1:register(v1)	: COLOR1 ,
					float2	tex0	:register(t0)	: TEXCOORD0,
					float4	vertPos	:register(t4)	: TEXCOORD4
				) : COLOR

{
	
	float4	outColorA;

	float4	texcolorA	= tex2D(TexA, tex0);

	outColorA.xyz	= saturate(diffuse0		* texcolorA);
	outColorA.w		= saturate(diffuse0.w	* texcolorA.w);
	outColorA.xyz	= saturate(outColorA + diffuse1);

	float distance = 	length(vertPos - light_R);
	if(distance > 100)
	{
		outColorA.xyz *= 0.2;
	}
	else
	{
		outColorA.xyz *= (0.2 + 1/distance);
	}

	return  outColorA;
}


/*
ps_1_1

#line 7 "l:\Rally_7\SourceMaterial\CodeBase\Game\Pc\HedgeHog3D\PixelShaders\Fog\Particle.nvp"
    def c0, 1, 0, 0, 1

#line 13
    tex t0

#line 16
    mul_sat r0.xyz, v0,		t0
  + mul_sat r0.w,	v0.w,	t0.w
    add_sat r0.xyz, r0,		v1
*/