//various

#include "spot.h"
float3 lightDir			: register	(c10);
float3 light_R			: register	(c11);
float3 light_L			: register	(c12);
float3 brake_L			: register	(c13);
float3 brake_R			: register	(c14);
float4 lightParameters	: register	(c15);


sampler	TexA			: register	(s0);
sampler	attenuationMap	: register	(s4);

float4 PShader(		float4	diffuse0:register(v0)	: COLOR0 ,  
					float4	diffuse1:register(v1)	: COLOR1 ,
					float2	tex0	:register(t0)	: TEXCOORD0,
					float4	vertPos	:register(t4)	: TEXCOORD4
				) : COLOR

{
	float4	outColor	= float4(0,0,0,0);
	float4 texcolorA	= tex2D(TexA, tex0);

	outColor.xyz		= saturate(texcolorA * diffuse0);
	outColor.w			= saturate(diffuse0.w * texcolorA.w);
	outColor.xyz		= saturate(outColor + diffuse1);

	
	float distance = 	length(vertPos - light_R);
	if(distance > lightParameters.x)
	{
		outColor.xyz *= 0.2;
	}
	else
	{
		outColor.xyz *= (spot(vertPos,light_R,lightDir,attenuationMap,lightParameters.x) + 
			spot(vertPos,light_L,lightDir,attenuationMap,lightParameters.x));
	}

	outColor.xyz *= lightParameters.w;

	return  outColor;
}


/*
sampler	TexA			: register	(s0);
float4 PShader(		float4	diffuse0:register(v0)	: COLOR0 ,  
					float4	diffuse1:register(v1)	: COLOR1 ,
					float2	tex0	:register(t0)	: TEXCOORD0
				) : COLOR

{
	float4	outColor	= float4(0,0,0,0);
	float4 texcolorA	= tex2D(TexA, tex0);

	outColor.xyz		= saturate(texcolorA * diffuse0);
	outColor.w			= saturate(diffuse0.w * texcolorA.w);
	outColor.xyz		= saturate(outColor + diffuse1);

	return  outColor;
}
*/

/*
    ps_2_0
    dcl v0
    dcl v1.xyz
    dcl t0.xy
    dcl_2d s0

    texld	r0,		t0,		s0

    mul_sat r0.xyz, r0,		v0
    mul_sat r0.w,	r0.w,	v0.w
    add_sat r0.xyz, r0,		v1
    mov oC0, r0
*/


/*
    ps_1_1

    def c0, 1, 0, 0, 1
    tex t0
    mul_sat r0.xyz, v0,		t0
  + mul_sat r0.w,	v0.w,	t0.w
    add_sat r0.xyz, r0,		v1
*/



/*
add_sat dest, src0, src1

This example loads the destination register (dest) with the sum of the two colors in the source operands 
(src0 and src1), and clamps the result into the range 0.0 to 1.0 for each component.
*/