
float spot(	float3 vertPos, 
			float3 lightPos, 
			float3 lightDir, 
			sampler attenuationMap,
			float range)
{
	float3 v2l = vertPos - lightPos;
	float distance = length(v2l);
	float attenuation = 0.2;


	float angle = dot(normalize(v2l), - lightDir);

	if(angle < 0)
	{
		attenuation = 0.2;
	}
	else
	{
		float2 uv = float2(angle, distance/range);

		float4 intensity = tex2D(attenuationMap, uv);
		attenuation = intensity.x;
	}
	return attenuation;
}